diff -ruN orig/ircd-hybrid/configure ircd-hybrid/configure
--- orig/ircd-hybrid/configure	2004-07-03 01:10:16.000000000 +0000
+++ ircd-hybrid/configure	2004-07-20 00:11:37.767555016 +0000
@@ -2,7 +2,7 @@
 # Guess values for system-dependent variables and create Makefiles.
 # Generated by GNU Autoconf 2.59 for ircd-hybrid 7-CURRENT.
 #
-# $Id: configure,v 7.257 2004/07/03 01:10:16 metalrock Exp $
+# $Id: configure.ac,v 7.89 2004/06/23 08:24:28 joshk Exp $
 #
 # Copyright (C) 2003 Free Software Foundation, Inc.
 # This configure script is free software; the Free Software Foundation
@@ -994,7 +994,7 @@
 This configure script is free software; the Free Software Foundation
 gives unlimited permission to copy, distribute and modify it.
 
-$Id: configure,v 7.257 2004/07/03 01:10:16 metalrock Exp $
+$Id: configure.ac,v 7.89 2004/06/23 08:24:28 joshk Exp $
 _ACEOF
   exit 0
 fi
@@ -10663,6 +10663,12 @@
 
 fi
 
+
+cat >>confdefs.h <<_ACEOF
+#define DEFAULT_UMODE (UMODE_VHOST | UMODE_INVISIBLE)
+_ACEOF
+
+
                                                                                                     ac_config_files="$ac_config_files Makefile etc/Makefile servlink/Makefile contrib/Makefile src/Makefile include/Makefile messages/Makefile modules/Makefile tools/Makefile doc/Makefile"
 
 
diff -ruN orig/ircd-hybrid/configure.ac ircd-hybrid/configure.ac
--- orig/ircd-hybrid/configure.ac	2004-06-23 08:24:28.000000000 +0000
+++ ircd-hybrid/configure.ac	2004-07-20 00:11:37.769554712 +0000
@@ -1131,6 +1131,10 @@
 	
 fi
 
+dnl This is totally a hack, but we'll go back and fix it later ;)
+dnl TODO: make this pretty
+AC_DEFINE_UNQUOTED(DEFAULT_UMODE, UMODE_VHOST | UMODE_INVISIBLE, [Default umode])
+
 AC_CONFIG_FILES(		\
 	Makefile		\
 dnl	iauth/Makefile		\
diff -ruN orig/ircd-hybrid/include/client.h ircd-hybrid/include/client.h
--- orig/ircd-hybrid/include/client.h	2004-02-24 03:36:18.000000000 +0000
+++ ircd-hybrid/include/client.h	2004-07-20 00:12:19.489212360 +0000
@@ -396,7 +396,7 @@
 #define UMODE_ALL	   UMODE_SERVNOTICE
 
 #define SEND_UMODES  (UMODE_INVISIBLE | UMODE_OPER | UMODE_WALLOP | \
-                      UMODE_ADMIN)
+                      UMODE_ADMIN | UMODE_VHOST )
 #define ALL_UMODES   (SEND_UMODES | UMODE_SERVNOTICE | UMODE_CCONN | \
                       UMODE_REJ | UMODE_SKILL | UMODE_FULL | UMODE_SPY | \
                       UMODE_NCHANGE | UMODE_OPERWALL | UMODE_DEBUG | \
diff -ruN orig/ircd-hybrid/include/setup.h.in ircd-hybrid/include/setup.h.in
--- orig/ircd-hybrid/include/setup.h.in	2004-02-16 22:37:46.000000000 +0000
+++ ircd-hybrid/include/setup.h.in	2004-07-20 00:11:37.770554560 +0000
@@ -321,3 +321,6 @@
 
 /* If system does not define u_int32_t, define to unsigned long int here. */
 #undef u_int32_t
+
+/* Default usermodes */
+#undef DEFAULT_UMODE
diff -ruN orig/ircd-hybrid/src/s_user.c ircd-hybrid/src/s_user.c
--- orig/ircd-hybrid/src/s_user.c	2003-12-31 01:54:14.000000000 +0000
+++ ircd-hybrid/src/s_user.c	2004-07-20 00:11:37.771554408 +0000
@@ -522,8 +522,18 @@
   if (IsDead(source_p))
     return(CLIENT_EXITED);
 
-  source_p->umodes |= UMODE_INVISIBLE;
-  Count.invisi++;
+  source_p->umodes |= DEFAULT_UMODE;
+  if (source_p->umodes & UMODE_VHOST) {
+    strncpy(source_p->orighost, source_p->host, HOSTLEN);
+    make_virthost(source_p->host, source_p->localClient->sockhost, source_p->host);
+    for( ptr = serv_list.head; ptr; ptr = ptr->next ) {
+      sendto_one( ptr->data, ":%s CHGHOST %s %s", me.name, source_p->name, source_p->host );
+    }
+    sendto_one(source_p, "NOTICE %s :*** Your host is masked (%s).", me.name, source_p->host);    
+  }
+
+  if (source_p->umodes & UMODE_INVISIBLE)
+    Count.invisi++;
 
   if ((++Count.local) > Count.max_loc)
   {
